<template>
	<div
		class="flex w-full h-full lg:w-470 flex-col md:rounded-lg lg:rounded bg-white px-0 pt-5 pb-6 md:px-4 md:pt-6 md:pb-8 lg:px-6 lg:pt-10 lg:pb-10 mb-4"
	>
		<div class="flex justify-between flex-row items-end px-4">
			<h2 class="font-secondary-font-regular text-xl md:text-2xl leading-6 md:leading-7 lg:leading-8">
				Order summary
			</h2>
			<p
				v-if="showSummary"
				tabindex="0"
				class="icon-up-arrow text-right text-black md:hidden text-2xl"
				aria-label="Order summary up arrow"
				aria-expanded="true"
				role="button"
				@click="show"
				@keypress.enter="show"
			></p>
			<p
				v-else
				class="icon-down-arrow text-right text-black md:hidden text-2xl"
				aria-label="Order summary down arrow"
				aria-expanded="false"
				tabindex="0"
				role="button"
				@click="show"
				@keypress.enter="show"
			></p>
			<p
				role="button"
				tabindex="0"
				class="font-primary-font-bold text-base leading-6 text-right hidden md:block cursor-pointer focus:outline-none focus:ring-1 focus:ring-black mk-link"
				@click="$router.push('/D2C/checkout/cart/')"
				@keypress.enter="$router.push('/D2C/checkout/cart/')"
			>
				Edit cart
			</p>
		</div>
		<div v-if="showSummary">
			<p
				role="button"
				tabindex="0"
				class="font-primary-font-bold text-base leading-6 text-right flex-row md:flex-col md:hidden mt-6 cursor-pointer px-4 text-black focus:outline-none focus:ring-1 focus:ring-black mk-link"
				@click="$router.push('/D2C/checkout/cart/')"
				@keypress.enter="$router.push('/D2C/checkout/cart/')"
			>
				Edit cart
			</p>
			<div v-for="(item, index) in productlist" :key="index" class="flex flex-col mt-8 px-4 lg:px-0 mr-0 lg:mr-4">
				<div class="flex flex-row">
					<div class="flex mr-4">
						<div role="img" :aria-label="item.name[apiLocale]" class="flex items-start justify-center">
							<MKProductImage size-class="w-17 h-17" :product-name="item.name[apiLocale]" :product-detail="item" />
						</div>
					</div>
					<div class="flex flex-col w-full text-black">
						<div class="flex flex-row justify-between">
							<div class="flex justify-between flex-col">
								<h3 class="text-xl leading-6 font-secondary-font-regular">
									{{ item.name[apiLocale] }}
								</h3>
								<span
									v-if="!isFilter(item) && !GIFT && item.cartItemHasSubscription && FEATURE_SUBSCRIPTION"
									class="screen-reader-only"
									>Includes {{ item['cartItemSubscriptionData']['period'] }}months of filters</span
								>
								<div
									v-if="!isFilter(item) && !GIFT && item.cartItemHasSubscription && FEATURE_SUBSCRIPTION"
									class="font-primary-font-light text-sm leading-5 mt-2"
									aria-hidden="”true”"
								>
									Includes {{ item['cartItemSubscriptionData']['period'] }}mos. of filters
								</div>
								<div
									class="flex text-base md:text-sm lg:text-base leading-6 md:leading-5 lg:leading-6 mt-2 font-primary-font-regular"
								>
									<p>
										Qty:
										<span class="pl-1 md:pl-0 lg:pl-0">{{ item.quantity }}</span>
									</p>
								</div>
							</div>
							<div
								class="flex text-base font-primary-font-bold lg:font-primary-font-regular leading-6 lg:leading-5 justify-end"
							>
								<div class="flex flex-col items-end">
									<MkActualPrice
										v-show="item.priceDisplay.strikePrice > 0"
										aria-hidden="true"
										:actual-price="item.priceDisplay.strikePrice"
									/>
									<p v-if="item.priceDisplay.strikePrice > 0" aria-live="polite" class="sr-only">
										Original price was {{ currencyDisplay
										}}{{ item.priceDisplay.strikePrice | centsToDollars | formatPrice }}, current price is
										{{ currencyDisplay }}{{ item.priceDisplay.price | centsToDollars | formatPrice }}
									</p>
									<p v-if="item.priceDisplay.strikePrice > 0" aria-hidden="true">
										{{ currencyDisplay }}{{ item.priceDisplay.price | centsToDollars | formatPrice }}
									</p>
									<p v-else>
										{{ currencyDisplay
										}}{{ (item.quantity * item.price.value['centAmount']) | centsToDollars | formatPrice }}
									</p>
								</div>
							</div>
						</div>
						<span v-if="!isFilter(item) && !GIFT && item.cartItemHasSubscription && FEATURE_SUBSCRIPTION">
							<MKFilterSubscription
								:item="item"
								:show-tooltip="true"
								:show-includes="false"
								:show-tooltip-option="showTooltipOption"
								:payment-data="paymentData"
							/>
							<div v-if="!paymentData.selectedAffirm">
								<p class="font-primary-font-light text-sm leading-5 mt-2">
									Next refill:
									{{ createNextRefill(item['cartItemSubscriptionData']['period']) }}
								</p>
								<span
									class="screen-reader-only"
									:aria-label="`$${getCentPrice(item['cartItemSubscriptionData']['price']['centAmount'])} every ${
										item['cartItemSubscriptionData']['period']
									} months per device`"
								></span>
								<p aria-hidden="true" class="font-primary-font-light text-sm leading-5 mt-2">
									{{ currencyDisplay
									}}{{ item['cartItemSubscriptionData']['price']['centAmount'] | centsToDollars }} every
									{{ item['cartItemSubscriptionData']['period'] }} mos per device
								</p>
							</div>
						</span>
					</div>
				</div>
				<MkClydeButton v-if="FEATURE_CLYDE" :is-checkout="true" :item="item" />
			</div>
			<MkOrderTotal class="mt-8 lg:mt-10 px-2 md:px-0" />
			<MkOrderPromo class="mb-4 lg:mb-6" />
			<MkOrderCheckout :is-checkout="true" :payment-data="paymentData" />
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkClydeButton from '~/components/D2C/atoms/MkClydeButton.vue';
import MkOrderTotal from '~/components/D2C/molecules/MkOrderTotal.vue';
import MkOrderPromo from '~/components/D2C/molecules/MkOrderPromo.vue';
import MkOrderCheckout from '~/components/D2C/molecules/MkOrderCheckout.vue';
import MKProductImage from '~/components/D2C/organisms/MkProductImage/MkProductImage.vue';
import MKFilterSubscription from '~/components/D2C/molecules/MkFilterSubscription/MkFilterSubscription.vue';
import MkActualPrice from '~/components/D2C/atoms/MkActualPrice.vue';
export default {
	name: 'MkCheckoutOrderSummary',
	components: {
		MkOrderTotal,
		MkOrderPromo,
		MkOrderCheckout,
		MKProductImage,
		MKFilterSubscription,
		MkClydeButton,
		MkActualPrice,
	},
	props: {
		paymentDetail: {
			type: Object,
			default: () => {},
		},
	},
	data() {
		return {
			paymentData: {},
			showTooltipOption: true,
			showSummary: true,
		};
	},
	computed: {
		...mapState(['currencyDisplay', 'isEurope', 'apiLocale']),
		...mapState('CART_STORE', ['GIFT']),
		...mapState('CHECKOUT_STORE', ['FEATURE_CLYDE', 'FEATURE_SUBSCRIPTION']),
		productlist() {
			return this.$store.state.CART_STORE.LINE_ITEMS;
		},
	},
	watch: {
		paymentDetail: {
			deep: true,
			handler() {
				this.paymentData = this.paymentDetail;
			},
		},
	},
	async mounted() {},
	methods: {
		getCentPrice($price) {
			return this.$options.filters.centsToDollars($price);
		},
		createNextRefill(value) {
			if (value) {
				const d = new Date();
				d.setMonth(d.getMonth() + value);
				return this.$options.filters.formatDateAurora(d, 'MM/DD/YYYY');
			}
		},
		show() {
			this.showSummary = !this.showSummary;
		},
		isFilter(item) {
			const isFilter =
				item &&
				item.productType &&
				item.productType.obj &&
				item.productType.obj.key &&
				item.productType.obj.key === 'filter';

			return isFilter;
		},
	},
};
</script>
<style lang="postcss">
.mk-strike::before {
	position: absolute;
	top: 0;
	width: 100%;
	height: 50%;
	content: '';
	border-bottom: 2px solid red;
}
</style>
